﻿-----------------------------------------------------------------------
-- Locale
-----------------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("Violation: Target Threat")

L:RegisterTranslations("enUS", function() return {
	["Target Threat"] = true,
	["TT"] = true,
} end)

--Chinese Translate by Ananhaid(NovaLOG)@CWDG
--CWDG site: http://Cwowaddon.com
L:RegisterTranslations("zhCN", function() return {
	["Target Threat"] = "目标仇恨",
	["TT"] = "目标仇恨(TT)",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Target Threat"] = "目標仇恨",
	["TT"] = "目標仇恨(TT)",
} end)

L:RegisterTranslations("koKR", function() return {
	["Target Threat"] = "대상 위협수준",
} end)

L:RegisterTranslations("frFR", function() return {
	["Target Threat"] = "Menace envers la cible",
	["TT"] = "MC",
} end)

-----------------------------------------------------------------------
-- Locals
-----------------------------------------------------------------------

local moduleName = "Target Threat"
local targetName = ""

local roster = AceLibrary("Roster-2.1")
local threat

-----------------------------------------------------------------------
-- Module declaration
-----------------------------------------------------------------------

local mod = Violation:NewModule(moduleName)
mod.revision = tonumber(("$Revision: 49446 $"):sub(12, -3)) or 1
mod.version = 5
mod.canMergeData = false
mod.canBroadcast = false
mod.violationCategory = "threat"
mod.dataFormatter = "%d"

-----------------------------------------------------------------------
-- Module initialization
-----------------------------------------------------------------------

function mod:OnModuleEnable()
	if not threat then
		threat = AceLibrary("Threat-1.0")
	end
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("Threat_ThreatUpdated")
	self:RegisterEvent("Threat_ThreatCleared")	
end

function mod:OnModuleDisable()
	self:UnregisterAllEvents()
end

-----------------------------------------------------------------------
-- Module implementation
-----------------------------------------------------------------------


function mod:GetDisplayName() return L["Target Threat"] end
function mod:GetShortDisplayName() return L["TT"] end

function mod:RefreshData(reset)
	self:Reset()
	if not reset then
		for name,value in threat:IterateGroupThreatForTarget(targetName) do
			if value and value > 0 then
				self.data[name] = value
			end
		end
	end
	self.dirty = true
	self:RequestDisplayRefresh()
end

function mod:PLAYER_TARGET_CHANGED()
	targetName = UnitName("target")
	self:RefreshData(not targetName)
end

function mod:Threat_ThreatUpdated( name, unit, target )
	if not threat:UnitIsUnit(targetName or "", target) then
		return
	end
	self.dirty = true
	self.data[name] = threat:GetThreat(name, target)

end

function mod:Threat_ThreatCleared()
	self:RefreshData(true)
end
